package xyz.lychee.lagfixer.libs.adventure.util;

import xyz.lychee.lagfixer.libs.adventure.text.Component;
import xyz.lychee.lagfixer.libs.annotations.Nullable;

public interface ComponentMessageThrowable {
   static @Nullable Component getMessage(final @Nullable Throwable throwable) {
      return throwable instanceof ComponentMessageThrowable ? ((ComponentMessageThrowable)throwable).componentMessage() : null;
   }

   static @Nullable Component getOrConvertMessage(final @Nullable Throwable throwable) {
      if (throwable instanceof ComponentMessageThrowable) {
         return ((ComponentMessageThrowable)throwable).componentMessage();
      } else {
         if (throwable != null) {
            String message = throwable.getMessage();
            if (message != null) {
               return Component.text(message);
            }
         }

         return null;
      }
   }

   @Nullable Component componentMessage();
}
